apiVersion: apps/v1
kind: Deployment
metadata:
  name: polyspheres
  namespace: legacy
  labels:
    app: polyspheres
spec:
  replicas: 1
  selector:
    matchLabels:
      app: polyspheres
  template:
    metadata:
      labels:
        app: polyspheres
    spec:
      affinity:
        podAffinity:
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchLabels:
                app: polyspheres
            topologyKey: kubernetes.io/hostname
      
      containers:
      - name: polyspheres
        image: registry.gitlab.com/agepoly/it/dev/polyspheres:latest
        imagePullPolicy: Always
        command:
        - npm
        - start
        
        env:
        - name: JWT_KEY
          valueFrom:
            secretKeyRef:
              key: JWT_KEY
              name: polyspheres-env-secrets
        - name: DB_USER
          valueFrom:
            secretKeyRef:
              key: DB_USER
              name: polyspheres-env-secrets
        - name: DB_NAME
          valueFrom:
            secretKeyRef:
              key: DB_NAME
              name: polyspheres-env-secrets
        - name: DB_PASSWORD
          valueFrom:
            secretKeyRef:
              key: DB_PASSWORD
              name: polyspheres-env-secrets
        - name: USE_PROXY
          value: "1"
        - name: DB_PORT
          value: "5432"
        - name: DB_HOST
          value: databases
        - name: NODE_ENV
          value: production
        - name: HOST
          value: polyspheres.agepoly.ch
        
        ports:
        - containerPort: 3000
          protocol: TCP
        
        resources: {}

        livenessProbe:
          failureThreshold: 2
          httpGet:
            httpHeaders:
            - name: Host
              value: polyspheres.agepoly.ch
            path: /
            port: 3000
            scheme: HTTP
          initialDelaySeconds: 300
          periodSeconds: 300
          successThreshold: 1
          timeoutSeconds: 10
        
        readinessProbe:
          failureThreshold: 1
          httpGet:
            httpHeaders:
            - name: Host
              value: polyspheres.agepoly.ch
            path: /
            port: 3000
            scheme: HTTP
          initialDelaySeconds: 5
          periodSeconds: 150
          successThreshold: 1
          timeoutSeconds: 10
        
        startupProbe:
          failureThreshold: 30
          httpGet:
            httpHeaders:
            - name: Host
              value: polyspheres.agepoly.ch
            path: /
            port: 3000
            scheme: HTTP
          initialDelaySeconds: 5
          periodSeconds: 10
          successThreshold: 1
          timeoutSeconds: 10

---
apiVersion: v1
kind: Service
metadata: 
  name: polyspheres
  namespace: legacy 
  labels:
    app: polyspheres
spec:
  ports:
  - name: http
    port: 80
    protocol: TCP
    targetPort: 3000
  selector:
    app: polyspheres
  type: ClusterIP

---
apiVersion: gateway.networking.k8s.io/v1beta1
kind: HTTPRoute
metadata:
  name: polyspheres
  namespace: legacy
spec:
  parentRefs:
  - name: vip-240
    sectionName: main
    namespace: istio-system
  hostnames: ["polyspheres.agepoly.ch"]
  rules:
  - matches:
    - path:
        type: PathPrefix
        value: /
    backendRefs:
    - name: polyspheres
      port: 80